/*
 * Barracuda 1.0.
 * Copyright (C) 1997 Magnus Christensson,
 *                    Stefan Cronert,
 *                    Stefan Hellkvist,
 *                    Magnus Ljung.
 *
 * Barracuda comes with ABSOLUTELY NO WARRANTY. For detailes see COPYING.
 */

#ifndef Preferences_included
#define Preferences_included

#include <qdialog.h>

#include "PreferencesData.h"
#include <options.h>
#include <qpixmap.h>

class Preferences : public QDialog,
			private PreferencesData
{
    Q_OBJECT

public:

    Preferences
    (
        QWidget* parent = NULL,
        const char* name = NULL
    );

    virtual ~Preferences();

    bool eShow(Options *o);
    void setWidgets(Options *o);

public slots:

    void ok();
    void cancel();
    void setDefault();
    void caseSense();
    void expandMacros();
    void lacyUpdate();
    void saveUnused();
    void showStartUp();
    void showWarnings();
    void verbose();
    void comboActive(int index);
    

private:
    Options *myopt, *oldopt;
    QPixmap *linepm, *dashlinepm;
    QPixmap *dottedlinepm, *dashdotlinepm, *dashdotdotlinepm;
};
#endif // Preferences_included




