#include "Search.h"

#define Inherited QDialog

Search::Search
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name, TRUE ),
	SearchData( this )
{
    QLineEdit *edits[] = {author, title, journal, year, key, volume, number, 
			  month, pages, note, annote, booktitle, crossref, 
			  editor, series, organization, publisher, address,
			  chapter, type, edition, howPublished, school,
			  institution, id};
    QCheckBox *boxes[] = {articleCheck, inProceedingsCheck, inCollectionCheck,
			  inBookCheck, proceedingsCheck, bookCheck, 
			  bookletCheck, phdThesisCheck, mastersThesisCheck,
			  techReportCheck, manualCheck, unpublishedCheck,
			  miscCheck};

    int i;

    for (i = 0; i <= (LAST_REFERENCE - FIRST_REFERENCE); i++)
	refChecks[i] = boxes[i];
    for (i = 0; i <= (LAST_FIELD - FIRST_FIELD + 1); i++)
	editFields[i] = edits[i];

    connect (searchBtn, SIGNAL (clicked ()), this, SLOT (search ()));
    connect (resetBtn, SIGNAL (clicked ()), this, SLOT (reset ()));
    connect (cancelBtn, SIGNAL (clicked ()), this, SLOT (cancel ()));
    connect (clearBtn, SIGNAL (clicked ()), this, SLOT (clear ()));
}


Search::~Search()
{
}


bool Search::eShow (Reference *searchRef, bool *refs)
{
    int i, j;

    this->fields = searchRef;
    this->refs = refs;

    for (j = 0, i = FIRST_FIELD; i <= LAST_FIELD + 1; i++, j++)
    {
	if (i == ID)
	    editFields[j]->setText (searchRef->id);
	else
	    editFields[j]->setText (searchRef->getField (i)->getString ());
    }
	    
    for (j = 0, i = FIRST_REFERENCE; i <= LAST_REFERENCE; i++, j++)
	refChecks[j]->setChecked (refs[j]);

    show ();
    return result ();
}

void Search::search ()
{
    int i, j;

    for (j = 0, i = FIRST_FIELD; i <= LAST_FIELD + 1; i++, j++)
    {
	if (i == ID)
	    fields->id = editFields[j]->text();
	else
	    fields->setField(i, (char *)editFields[j]->text(), STRING, TRUE);
    }
	    
    for (j = 0, i = FIRST_REFERENCE; i <= LAST_REFERENCE; i++, j++)
	refs[j] = refChecks[j]->isChecked ();

    done (TRUE);
}    


void Search::reset ()
{
    int i, j;

    for (j = 0, i = FIRST_FIELD; i <= LAST_FIELD + 1; i++, j++)
	editFields[j]->setText(".*");
	    
    for (j = 0, i = FIRST_REFERENCE; i <= LAST_REFERENCE; i++, j++)
	refChecks[j]->setChecked (TRUE);
}

void Search::clear ()
{
    int i, j;

    for (j = 0, i = FIRST_FIELD; i <= LAST_FIELD + 1; i++, j++)
	editFields[j]->setText("");
	    
    for (j = 0, i = FIRST_REFERENCE; i <= LAST_REFERENCE; i++, j++)
	refChecks[j]->setChecked (FALSE);
}

void Search::cancel ()
{
    done (FALSE);
}
    

